/*******************************************************************************
 *  Copyright 2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MeasuredOrCalculated;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_MeasuredOrCalculated;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumRadiologySNOMEDMap;

/**
 * This class represents MeasuredOrCalculated CID10009
 */
public class MeasuredOrCalculated_CID10009 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new MeasuredOrCalculated_CID10009 Template 
	 */
	public MeasuredOrCalculated_CID10009()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumMeasuredOrCalculated Object of EnumCM_MeasuredOrCalculated represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_MeasuredOrCalculated enumMeasuredOrCalculated)
	{
		switch(enumMeasuredOrCalculated)
		{
		case MEASURED: this.strCodeValue =EnumCV_MeasuredOrCalculated.MEASURED_R_41D41.getValue(); break;
		case CALCULATED: this.strCodeValue =EnumCV_MeasuredOrCalculated.CALCULATED_R_41D2D.getValue(); break;
		case ESTIMATED: this.strCodeValue =EnumCV_MeasuredOrCalculated.ESTIMATED_R_10260.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumMeasuredOrCalculated Object of EnumCM_MeasuredOrCalculated represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_MeasuredOrCalculated enumMeasuredOrCalculated)
	{
		switch(enumMeasuredOrCalculated)
		{
		case MEASURED : this.strSNOMEDCTID =EnumRadiologySNOMEDMap.MEASURED.getSNOMEDCTID(); break;
		case CALCULATED : this.strSNOMEDCTID =EnumRadiologySNOMEDMap.CALCULATED.getSNOMEDCTID(); break;
		case ESTIMATED : this.strSNOMEDCTID =EnumRadiologySNOMEDMap.ESTIMATED.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for MeasuredOrCalculated
	 * @param enumMeasuredOrCalculated Object of EnumCM_MeasuredOrCalculated.
	 */
	public void setMeasuredOrCalculated(EnumCM_MeasuredOrCalculated enumMeasuredOrCalculated)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumMeasuredOrCalculated.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumMeasuredOrCalculated);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumMeasuredOrCalculated);
	}
}
